import type { App } from 'vue'
import type { ByinOptions } from './types'

const COMPONENT_PREFIX = 'Byin'
const CLASS_PREFIX = 'byin'
const GLOBAL_CONFIG_NAME = '$byin'

export const getComponentPrefix = () => {
	return COMPONENT_PREFIX
}

export const setGlobalConfig = (app: App, options?: ByinOptions): void => {
	if (options && options.classPrefix) {
		app.config.globalProperties[GLOBAL_CONFIG_NAME] = {
			...(app.config.globalProperties[GLOBAL_CONFIG_NAME] ?? {}),
			classPrefix: options.classPrefix
		}
	}
}

export const getPrefixCls = (componentName?: string): string => {
	const prefix = CLASS_PREFIX
	if (componentName) {
		return `${prefix}-${componentName}`
	}
	return prefix
}
